Package org.apache.commons.compress.archivers.zip

# Enum ZipMethod

java.lang.Object
java.lang.Enum<ZipMethod>
org.apache.commons.compress.archivers.zip.ZipMethod

All Implemented Interfaces:
  `Serializable`, `Comparable<ZipMethod>`

public enum ZipMethod extends Enum<ZipMethod>
List of known compression methods Many of these methods are currently not supported by commons compress

Since:
  1.5

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `AES_ENCRYPTED`
  Compression Method 99 for AES encryption.
  `BZIP2`
  Compression Method 12 for bzip2.
  `DEFLATED`
  Compression method 8 for compressed (deflated) entries.
  `ENHANCED_DEFLATED`
  Compression Method 9 for enhanced deflate.
  `EXPANDING_LEVEL_1`
  Reduced with compression factor 1.
  `EXPANDING_LEVEL_2`
  Reduced with compression factor 2.
  `EXPANDING_LEVEL_3`
  Reduced with compression factor 3.
  `EXPANDING_LEVEL_4`
  Reduced with compression factor 4.
  `IMPLODING`
  Imploding.
  `JPEG`
  Compression Method 96 for Jpeg compression.
  `LZMA`
  Compression Method 14 for LZMA.
  `PKWARE_IMPLODING`
  PKWARE Data Compression Library Imploding.
  `PPMD`
  Compression Method 98 for PPMd.
  `STORED`
  Compression method 0 for uncompressed entries.
  `TOKENIZATION`
  Tokenization.
  `UNKNOWN`
  Unknown compression method.
  `UNSHRINKING`
  UnShrinking. dynamic Lempel-Ziv-Welch-Algorithm
  `WAVPACK`
  Compression Method 97 for WavPack.
  `XZ`
  Compression Method 95 for XZ.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `getCode()`
  the code of the compression method.
  `static ZipMethod`
  `getMethodByCode(int code)`
  returns the `ZipMethod` for the given code or null if the method is not known.
  `static ZipMethod`
  `valueOf(String name)`
  Returns the enum constant of this type with the specified name.
  `static ZipMethod[]`
  `values()`
  Returns an array containing the constants of this enum type, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### STORED

    public static final ZipMethod STORED
    Compression method 0 for uncompressed entries.
    See Also:
      - `ZipEntry.STORED`

  - ### UNSHRINKING

    public static final ZipMethod UNSHRINKING
    UnShrinking. dynamic Lempel-Ziv-Welch-Algorithm
    See Also:
      - Explanation of fields: compression method: (2 bytes)

  - ### EXPANDING_LEVEL_1

    public static final ZipMethod EXPANDING_LEVEL_1
    Reduced with compression factor 1.
    See Also:
      - Explanation of fields: compression method: (2 bytes)

  - ### EXPANDING_LEVEL_2

    public static final ZipMethod EXPANDING_LEVEL_2
    Reduced with compression factor 2.
    See Also:
      - Explanation of fields: compression method: (2 bytes)

  - ### EXPANDING_LEVEL_3

    public static final ZipMethod EXPANDING_LEVEL_3
    Reduced with compression factor 3.
    See Also:
      - Explanation of fields: compression method: (2 bytes)

  - ### EXPANDING_LEVEL_4

    public static final ZipMethod EXPANDING_LEVEL_4
    Reduced with compression factor 4.
    See Also:
      - Explanation of fields: compression method: (2 bytes)

  - ### IMPLODING

    public static final ZipMethod IMPLODING
    Imploding.
    See Also:
      - Explanation of fields: compression method: (2 bytes)

  - ### TOKENIZATION

    public static final ZipMethod TOKENIZATION
    Tokenization.
    See Also:
      - Explanation of fields: compression method: (2 bytes)

  - ### DEFLATED

    public static final ZipMethod DEFLATED
    Compression method 8 for compressed (deflated) entries.
    See Also:
      - `ZipEntry.DEFLATED`

  - ### ENHANCED_DEFLATED

    public static final ZipMethod ENHANCED_DEFLATED
    Compression Method 9 for enhanced deflate.
    See Also:
      - https://www.winzip.com/wz54.htm

  - ### PKWARE_IMPLODING

    public static final ZipMethod PKWARE_IMPLODING
    PKWARE Data Compression Library Imploding.
    See Also:
      - https://www.winzip.com/wz54.htm

  - ### BZIP2

    public static final ZipMethod BZIP2
    Compression Method 12 for bzip2.
    See Also:
      - https://www.winzip.com/wz54.htm

  - ### LZMA

    public static final ZipMethod LZMA
    Compression Method 14 for LZMA.
    See Also:
      - https://www.7-zip.org/sdk.html
      - https://www.winzip.com/wz54.htm

  - ### XZ

    public static final ZipMethod XZ
    Compression Method 95 for XZ.
    See Also:
      - https://www.winzip.com/wz54.htm

  - ### JPEG

    public static final ZipMethod JPEG
    Compression Method 96 for Jpeg compression.
    See Also:
      - https://www.winzip.com/wz54.htm

  - ### WAVPACK

    public static final ZipMethod WAVPACK
    Compression Method 97 for WavPack.
    See Also:
      - https://www.winzip.com/wz54.htm

  - ### PPMD

    public static final ZipMethod PPMD
    Compression Method 98 for PPMd.
    See Also:
      - https://www.winzip.com/wz54.htm

  - ### AES_ENCRYPTED

    public static final ZipMethod AES_ENCRYPTED
    Compression Method 99 for AES encryption.
    See Also:
      - https://www.winzip.com/wz54.htm

  - ### UNKNOWN

    public static final ZipMethod UNKNOWN
    Unknown compression method.

- ## Method Details

  - ### values

    public static ZipMethod[] values()
    Returns an array containing the constants of this enum type, in the order they are declared.
    Returns:
      an array containing the constants of this enum type, in the order they are declared

  - ### valueOf

    public static ZipMethod valueOf(String name)
    Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum type has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### getMethodByCode

    public static ZipMethod getMethodByCode(int code)
    returns the `ZipMethod` for the given code or null if the method is not known.
    Parameters:
      `code` - the code
    Returns:
      the `ZipMethod` for the given code or null if the method is not known.

  - ### getCode

    public int getCode()
    the code of the compression method.
    Returns:
      an integer code for the method
    See Also:
      - `ZipArchiveEntry.getMethod()`